Index: CKEditor/trunk/_source/plugins/pagebreak/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/pagebreak/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/pagebreak/plugin.js	(revision 6904)
@@ -23,29 +23,64 @@
 			});
 
+		var cssStyles = [
+			'{' ,
+				'background: url(' + CKEDITOR.getUrl( this.path + 'images/pagebreak.gif' ) + ') no-repeat center center;' ,
+				'clear: both;' ,
+				'width:100%; _width:99.9%;' ,
+				'border-top: #999999 1px dotted;' ,
+				'border-bottom: #999999 1px dotted;' ,
+				'padding:0;' ,
+				'height: 5px;' ,
+				'cursor: default;' ,
+			'}'
+			].join( '' ).replace(/;/g, ' !important;' );	// Increase specificity to override other styles, e.g. block outline.
+
 		// Add the style that renders our placeholder.
-		editor.addCss(
-			'img.cke_pagebreak' +
-			'{' +
-				'background-image: url(' + CKEDITOR.getUrl( this.path + 'images/pagebreak.gif' ) + ');' +
-				'background-position: center center;' +
-				'background-repeat: no-repeat;' +
-				'clear: both;' +
-				'display: block;' +
-				'float: none;' +
-				'width:100% !important; _width:99.9% !important;' +
-				'border-top: #999999 1px dotted;' +
-				'border-bottom: #999999 1px dotted;' +
-				'height: 5px !important;' +
-				'page-break-after: always;' +
+		editor.addCss( 'div.cke_pagebreak' + cssStyles );
 
-			'}' );
+		// Opera needs help to select the page-break.
+		CKEDITOR.env.opera && editor.on( 'contentDom', function()
+		{
+			editor.document.on( 'click', function( evt )
+			{
+				var target = evt.data.getTarget();
+				if ( target.is( 'div' ) && target.hasClass( 'cke_pagebreak')  )
+					editor.getSelection().selectElement( target );
+			});
+		});
 	},
 
 	afterInit : function( editor )
 	{
+		var label = editor.lang.pagebreakAlt;
+
 		// Register a filter to displaying placeholders after mode change.
+		var dataProcessor = editor.dataProcessor,
+			dataFilter = dataProcessor && dataProcessor.dataFilter,
+			htmlFilter = dataProcessor && dataProcessor.htmlFilter;
 
-		var dataProcessor = editor.dataProcessor,
-			dataFilter = dataProcessor && dataProcessor.dataFilter;
+		if ( htmlFilter )
+		{
+			htmlFilter.addRules(
+			{
+				attributes : {
+					'class' : function( value, element )
+					{
+						var className =  value.replace( 'cke_pagebreak', '' );
+						if ( className != value )
+						{
+							var span = CKEDITOR.htmlParser.fragment.fromHtml( '<span style="display: none;">&nbsp;</span>' );
+							element.children.length = 0;
+							element.add( span );
+							var attrs = element.attributes;
+							delete attrs[ 'aria-label' ];
+							delete attrs.contenteditable;
+							delete attrs.title;
+						}
+						return className;
+					}
+				}
+			}, 5 );
+		}
 
 		if ( dataFilter )
@@ -64,9 +99,11 @@
 							if ( childStyle && ( /page-break-after\s*:\s*always/i ).test( style ) && ( /display\s*:\s*none/i ).test( childStyle ) )
 							{
-								var fakeImg = editor.createFakeParserElement( element, 'cke_pagebreak', 'div' );
-								var label = editor.lang.pagebreakAlt;
-								fakeImg.attributes[ 'alt' ] = label;
-								fakeImg.attributes[ 'aria-label' ] = label;
-								return fakeImg;
+								attributes.contenteditable = "false";
+								attributes[ 'class' ] = "cke_pagebreak";
+								attributes[ 'data-cke-display-name' ] = "pagebreak";
+								attributes[ 'aria-label' ] = label;
+								attributes[ 'title' ] = label;
+
+								element.children.length = 0;
 							}
 						}
@@ -83,11 +120,16 @@
 	exec : function( editor )
 	{
-		// Create the element that represents a print break.
 		var label = editor.lang.pagebreakAlt;
-		var breakObject = CKEDITOR.dom.element.createFromHtml( '<div style="page-break-after: always;"><span style="display: none;">&nbsp;</span></div>' );
 
-		// Creates the fake image used for this element.
-		breakObject = editor.createFakeElement( breakObject, 'cke_pagebreak', 'div' );
-		breakObject.setAttributes( { alt : label, 'aria-label' : label, title : label } );
+		// Create read-only element that represents a print break.
+		var pagebreak = CKEDITOR.dom.element.createFromHtml(
+			'<div style="' +
+			'page-break-after: always;"' +
+			'contenteditable="false" ' +
+			'title="'+ label + '" ' +
+			'aria-label="'+ label + '" ' +
+			'data-cke-display-name="pagebreak" ' +
+			'class="cke_pagebreak">' +
+			'</div>' );
 
 		var ranges = editor.getSelection().getRanges( true );
@@ -100,18 +142,20 @@
 
 			if ( i < ranges.length -1 )
-				breakObject = breakObject.clone( true );
+				pagebreak = pagebreak.clone( true );
 
 			range.splitBlock( 'p' );
-			range.insertNode( breakObject );
+			range.insertNode( pagebreak );
 			if ( i == ranges.length - 1 )
 			{
-				range.moveToPosition( breakObject, CKEDITOR.POSITION_AFTER_END );
+				var next = pagebreak.getNext();
+				range.moveToPosition( pagebreak, CKEDITOR.POSITION_AFTER_END );
+
+				// If there's nothing or a non-editable block followed by, establish a new paragraph
+				// to make sure cursor is not trapped.
+				if ( !next || next.type == CKEDITOR.NODE_ELEMENT && !next.isEditable() )
+					range.fixBlock( true, editor.config.enterMode == CKEDITOR.ENTER_DIV ? 'div' : 'p'  );
+
 				range.select();
 			}
-
-			var previous = breakObject.getPrevious();
-
-			if ( previous && CKEDITOR.dtd[ previous.getName() ].div )
-				breakObject.move( previous );
 		}
 
Index: CKEditor/trunk/_source/plugins/panel/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/panel/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/panel/plugin.js	(revision 6904)
@@ -17,5 +17,5 @@
  * @example
  */
-CKEDITOR.UI_PANEL = 2;
+CKEDITOR.UI_PANEL = 'panel';
 
 CKEDITOR.ui.panel = function( document, definition )
Index: CKEditor/trunk/_source/plugins/panelbutton/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/panelbutton/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/panelbutton/plugin.js	(revision 6904)
@@ -18,5 +18,5 @@
  * @example
  */
-CKEDITOR.UI_PANELBUTTON = 4;
+CKEDITOR.UI_PANELBUTTON = 'panelbutton';
 
 (function()
Index: CKEditor/trunk/_source/plugins/preview/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/preview/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/preview/plugin.js	(revision 6904)
@@ -14,4 +14,5 @@
 		modes : { wysiwyg:1, source:1 },
 		canUndo : false,
+		readOnly : 1,
 		exec : function( editor )
 		{
Index: CKEditor/trunk/_source/plugins/print/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/print/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/print/plugin.js	(revision 6904)
@@ -38,4 +38,5 @@
 	},
 	canUndo : false,
+	readOnly : 1,
 	modes : { wysiwyg : !( CKEDITOR.env.opera ) }		// It is imposible to print the inner document in Opera.
 };
Index: CKEditor/trunk/_source/plugins/richcombo/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/richcombo/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/richcombo/plugin.js	(revision 6904)
@@ -19,5 +19,5 @@
  * @example
  */
-CKEDITOR.UI_RICHCOMBO = 3;
+CKEDITOR.UI_RICHCOMBO = 'richcombo';
 
 CKEDITOR.ui.richCombo = CKEDITOR.tools.createClass(
@@ -129,10 +129,14 @@
 			};
 
-			editor.on( 'mode', function()
-				{
-					this.setState( this.modes[ editor.mode ] ? CKEDITOR.TRISTATE_OFF : CKEDITOR.TRISTATE_DISABLED );
-					this.setValue( '' );
-				},
-				this );
+			function updateState()
+			{
+				var state = this.modes[ editor.mode ] ? CKEDITOR.TRISTATE_OFF : CKEDITOR.TRISTATE_DISABLED;
+				this.setState( editor.readOnly && !this.readOnly ? CKEDITOR.TRISTATE_DISABLED : state );
+				this.setValue( '' );
+			}
+
+			editor.on( 'mode', updateState, this );
+			// If this combo is sensitive to readOnly state, update it accordingly.
+			!this.readOnly && editor.on( 'readOnly', updateState, this);
 
 			var keyDownFn = CKEDITOR.tools.addFunction( function( ev, element )
@@ -162,5 +166,5 @@
 
 			output.push(
-				'<span class="cke_rcombo">',
+				'<span class="cke_rcombo" role="presentation">',
 				'<span id=', id );
 
@@ -169,5 +173,5 @@
 
 			output.push(
-				'>',
+				' role="presentation">',
 					'<span id="' + id+ '_label" class=cke_label>', this.label, '</span>',
 					'<a hidefocus=true title="', this.title, '" tabindex="-1"',
Index: CKEditor/trunk/_source/plugins/save/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/save/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/save/plugin.js	(revision 6904)
@@ -13,4 +13,5 @@
 	{
 		modes : { wysiwyg:1, source:1 },
+		readOnly : 1,
 
 		exec : function( editor )
Index: CKEditor/trunk/_source/plugins/selection/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/selection/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/selection/plugin.js	(revision 6904)
@@ -93,4 +93,5 @@
 	{
 		modes : { wysiwyg : 1, source : 1 },
+		readOnly : CKEDITOR.env.ie || CKEDITOR.env.webkit,
 		exec : function( editor )
 		{
Index: CKEditor/trunk/_source/plugins/showblocks/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/showblocks/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/showblocks/plugin.js	(revision 6904)
@@ -90,4 +90,5 @@
 	var commandDefinition =
 	{
+		readOnly : 1,
 		preserveState : true,
 		editorFocus : false,
@@ -101,6 +102,9 @@
 		refresh : function( editor )
 		{
-			var funcName = ( this.state == CKEDITOR.TRISTATE_ON ) ? 'addClass' : 'removeClass';
-			editor.document.getBody()[ funcName ]( 'cke_show_blocks' );
+			if ( editor.document )
+			{
+				var funcName = ( this.state == CKEDITOR.TRISTATE_ON ) ? 'addClass' : 'removeClass';
+				editor.document.getBody()[ funcName ]( 'cke_show_blocks' );
+			}
 		}
 	};
Index: CKEditor/trunk/_source/plugins/showborders/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/showborders/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/showborders/plugin.js	(revision 6904)
@@ -41,4 +41,5 @@
 		preserveState : true,
 		editorFocus : false,
+		readOnly: 1,
 
 		exec : function ( editor )
@@ -50,6 +51,9 @@
 		refresh : function( editor )
 		{
-			var funcName = ( this.state == CKEDITOR.TRISTATE_ON ) ? 'addClass' : 'removeClass';
-			editor.document.getBody()[ funcName ]( 'cke_show_borders' );
+			if ( editor.document )
+			{
+				var funcName = ( this.state == CKEDITOR.TRISTATE_ON ) ? 'addClass' : 'removeClass';
+				editor.document.getBody()[ funcName ]( 'cke_show_borders' );
+			}
 		}
 	};
Index: CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js
===================================================================
--- CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js	(revision 6904)
@@ -184,4 +184,5 @@
 	{
 		type : 'html',
+		id : 'smileySelector',
 		html : html.join( '' ),
 		onLoad : function( event )
Index: CKEditor/trunk/_source/plugins/sourcearea/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/sourcearea/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/sourcearea/plugin.js	(revision 6904)
@@ -41,4 +41,6 @@
 							textarea.addClass( 'cke_source' );
 							textarea.addClass( 'cke_enable_context_menu' );
+
+							editor.readOnly && textarea.setAttribute( 'readOnly', 'readonly' );
 
 							var styles =
@@ -146,4 +148,15 @@
 						}
 					});
+			});
+
+		editor.on( 'readOnly', function()
+			{
+				if ( editor.mode == 'source' )
+				{
+					if ( editor.readOnly )
+						editor.textarea.setAttribute( 'readOnly', 'readonly' );
+					else
+						editor.textarea.removeAttribute( 'readOnly' );
+				}
 			});
 
@@ -182,5 +195,5 @@
 			modes : { wysiwyg:1, source:1 },
 			editorFocus : false,
-
+			readOnly : 1,
 			exec : function( editor )
 			{
Index: CKEditor/trunk/_source/plugins/styles/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/styles/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/styles/plugin.js	(revision 6904)
@@ -214,5 +214,5 @@
 		checkElementRemovable : function( element, fullMatch )
 		{
-			if ( !element )
+			if ( !element || element.isReadOnly() )
 				return false;
 
@@ -289,5 +289,5 @@
 
 		// Builds the preview HTML based on the styles definition.
-		buildPreview : function()
+		buildPreview : function( label )
 		{
 			var styleDefinition = this._.definition,
@@ -316,5 +316,5 @@
 				html.push( ' style="', cssStyle, '"' );
 
-			html.push( '>', styleDefinition.name, '</', elementName, '>' );
+			html.push( '>', ( label || styleDefinition.name ), '</', elementName, '>' );
 
 			return html.join( '' );
Index: CKEditor/trunk/_source/plugins/stylescombo/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/stylescombo/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/stylescombo/plugin.js	(revision 6904)
@@ -15,5 +15,6 @@
 				lang = editor.lang.stylesCombo,
 				styles = {},
-				stylesList = [];
+				stylesList = [],
+				combo;
 
 			function loadStylesSet( callback )
@@ -63,5 +64,5 @@
 					init : function()
 					{
-						var combo = this;
+						combo = this;
 
 						loadStylesSet( function()
@@ -182,4 +183,20 @@
 						if ( !counter[ CKEDITOR.STYLE_OBJECT ] )
 							this.hideGroup( lang[ 'panelTitle' + String( CKEDITOR.STYLE_OBJECT ) ] );
+					},
+
+					// Force a reload of the data
+					reset: function()
+					{
+						if ( combo )
+						{
+							delete combo._.panel;
+							delete combo._.list;
+							combo._.committed = 0;
+							combo._.items = {};
+							combo._.state = CKEDITOR.TRISTATE_OFF;
+						}
+						styles = {};
+						stylesList = [];
+						loadStylesSet();
 					}
 				});
Index: CKEditor/trunk/_source/plugins/stylesheetparser/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/stylesheetparser/plugin.js	(revision 6904)
+++ CKEditor/trunk/_source/plugins/stylesheetparser/plugin.js	(revision 6904)
@@ -0,0 +1,143 @@
+﻿/*
+Copyright (c) 2003-2011, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+/**
+ * @stylesheetParser plugin.
+ */
+
+(function()
+{
+	// We want to extract only the elements with classes defined in the stylesheets:
+	function parseClasses( aRules, skipSelectors, validSelectors )
+	{
+		// aRules are just the different rules in the style sheets
+		// We want to merge them and them split them by commas, so we end up with only
+		// the selectors
+		var s = aRules.join(' ');
+		// Remove selectors splitting the elements, leave only the class selector (.)
+		s = s.replace( /(,|>|\+|~)/g, ' ' );
+		// Remove attribute selectors: table[border="0"]
+		s = s.replace( /\[[^\]]*/g, '' );
+		// Remove Ids: div#main
+		s = s.replace( /#[^\s]*/g, '' );
+		// Remove pseudo-selectors and pseudo-elements: :hover :nth-child(2n+1) ::before
+		s = s.replace( /\:{1,2}[^\s]*/g, '' );
+
+		s = s.replace( /\s+/g, ' ' );
+
+		var aSelectors = s.split( ' ' ),
+			aClasses = [];
+
+		for ( var i = 0; i < aSelectors.length ; i++ )
+		{
+			var selector = aSelectors[ i ];
+
+			if ( validSelectors.test( selector ) && !skipSelectors.test( selector ) )
+			{
+				// If we still don't know about this one, add it
+				if ( CKEDITOR.tools.indexOf( aClasses, selector ) == -1 )
+					aClasses.push( selector );
+			}
+		}
+
+		return aClasses;
+	}
+
+	function LoadStylesCSS( theDoc, skipSelectors, validSelectors )
+	{
+		var styles = [],
+			// It will hold all the rules of the applied stylesheets (except those internal to CKEditor)
+			aRules = [],
+			i;
+
+		for ( i = 0; i < theDoc.styleSheets.length; i++ )
+		{
+			var sheet = theDoc.styleSheets[ i ],
+				node = sheet.ownerNode || sheet.owningElement;
+
+			// Skip the internal stylesheets
+			if ( node.getAttribute( 'data-cke-temp' ) )
+				continue;
+
+			// Exclude stylesheets injected by extensions
+			if ( sheet.href && sheet.href.substr(0, 9) == 'chrome://' )
+				continue;
+
+			var sheetRules = sheet.cssRules || sheet.rules;
+			for ( var j = 0; j < sheetRules.length; j++ )
+				aRules.push( sheetRules[ j ].selectorText );
+		}
+
+		var aClasses = parseClasses( aRules, skipSelectors, validSelectors );
+
+		// Add each style to our "Styles" collection.
+		for ( i = 0; i < aClasses.length; i++ )
+		{
+			var oElement = aClasses[ i ].split( '.' ),
+				element = oElement[ 0 ].toLowerCase(),
+				sClassName = oElement[ 1 ];
+
+			styles.push( {
+				name : element + '.' + sClassName,
+				element : element,
+				attributes : {'class' : sClassName}
+			});
+		}
+
+		return styles;
+	}
+
+	// Register a plugin named "stylesheetparser".
+	CKEDITOR.plugins.add( 'stylesheetparser',
+	{
+		requires: [ 'styles' ],
+		onLoad : function()
+		{
+			var obj = CKEDITOR.editor.prototype;
+			obj.getStylesSet = CKEDITOR.tools.override( obj.getStylesSet,  function( org )
+			{
+				return function( callback )
+				{
+					var self = this;
+					org.call( this, function( definitions )
+					{
+						// Rules that must be skipped
+						var skipSelectors = self.config.stylesheetParser_skipSelectors || ( /(^body\.|^\.)/i ),
+							// Rules that are valid
+							validSelectors = self.config.stylesheetParser_validSelectors || ( /\w+\.\w+/ );
+
+						callback( ( self._.stylesDefinitions = definitions.concat( LoadStylesCSS( self.document.$, skipSelectors, validSelectors ) ) ) );
+					});
+				};
+			});
+
+		}
+	});
+})();
+
+
+/**
+ * Regular Expression to check if a css rule must be skipped by
+ * the stylesheet parser plugin (so it's ignored and not available)
+ * @name CKEDITOR.config.stylesheetParser_skipSelectors
+ * @type RegExp
+ * @default /(^body\.|^\.)/i
+ * @since 3.6
+ * @example
+ * // Ignore rules for body, caption, only a class or classes starting with "high".
+ * config.stylesheetParser_skipSelectors = /(^body\.|^caption\.|\.high|^\.)/i;
+ */
+
+ /**
+ * Regular Expression to check if a css rule must be allowed by
+ * the stylesheet parser plugin
+ * @name CKEDITOR.config.stylesheetParser_validSelectors
+ * @type RegExp
+ * @default /\w+\.\w+/
+ * @since 3.6
+ * @example
+ * // Add only rules for p and span elements.
+ * config.stylesheetParser_validSelectors = /\^(p|span)\.\w+/;
+ */
